#!/usr/bin/perl -w 
#

$name="Blade's Debian abbreviation to URL converter";
$version="0.6";

IRC::register($name, $version, "", "");
IRC::print("$name (v.$version) loaded.");
IRC::add_command_handler("debab", "debab");
IRC::add_print_handler("Channel Message","chan_msg_debab");
IRC::add_print_handler("Your Message","ur_msg_debab");
IRC::add_print_handler("Channel Msg Hilight","msg_hi_debab");
IRC::add_print_handler("Channel Action","ch_action_debab");
IRC::add_print_handler("Channel Action Hilight","ch_act_hi_debab");
IRC::add_print_handler("Private Message","prv_msg_debab");
IRC::add_print_handler("Private Message to Dialog","prv_msg_dlg_debab");
IRC::add_print_handler("Topic","topic_debab");
IRC::add_print_handler("New Topic","new_topic_debab");

# the strings will be interpreted by perl (between quotes) with eval
%formats = (
    chan_msg  => "\\cC2<\\cO\$nick\\cC2>\\cO \$message",
    ur_msg    => "\\cC6<\\cO\$nick\\cC6>\\cO \$message",
    msg_hi    => "\\cC2<\\cC8\\cB\$nick\\cB\\cC2>\\cO \$message",
    ch_action => "\\cC13*\\cO\t\$nick \$message",
    ch_act_hi => "\\cC13*\\cO\t\\cC8\\cB\$nick\\cB\\cO \$message\cO",
    prv_msg   => "\\cC12*\\cC13\$nick\\cC12*\t\\cO\$message\\cO",
    prv_msg_dlg => "\\cC2<\\cO\$nick\\cC2>\\cO\t\$message\\cO", 
    topic_debab => "\$message",
    new_topic_debab => "\$message"
);

my $char1 = "\xC0-\xCF\xD2-\xD6\xD8-\xDD";
my $char2 = "\xE0-\xF6\xF8-\xFF";

sub new_message_debab;

sub generic_handler_debab
{
	($blah,$nick, $message) = split(/ /,$_[1],3);

        if( $_[0] eq "chan_msg" || $_[0] eq "msg_hi" || $_[0] eq "ur_msg") {
               	# removes mode char
        	$message =~ s/ +[^ ]?$//;
        }

        # get_info(3) -> server; get_info(2) -> channel
	new_message_debab IRC::get_info(3) , IRC::get_info(2),$nick,$message,$_[0];
}

sub prv_msg_dlg_debab
{
         generic_handler_debab "prv_msg_dlg", $_[0];
}

sub prv_msg_debab
{
         generic_handler_debab "prv_msg", $_[0];
}


sub ch_act_hi_debab
{
         generic_handler_debab "ch_act_hi", $_[0];
}

sub ch_action_debab
{
     generic_handler_debab "ch_action", $_[0];
}

sub chan_msg_debab
{
    generic_handler_debab "chan_msg", $_[0];
}

sub ur_msg_debab
{
    generic_handler_debab "ur_msg" , $_[0];
}

sub msg_hi_debab
{
    generic_handler_debab "msg_hi" , $_[0];
}

sub topic_debab
{
    generic_handler_debab "topic_debab" , $_[0];
}

sub new_topic_debab
{
    generic_handler_debab "new_topic_debab" , $_[0];
}

sub new_message_debab
{
	$server = $_[0];
	$channel = $_[1];
	$nick = $_[2];
	$message = $_[3];
	$msg_type = $_[4];
  $msg_prev=$message;

  $message =~s/Bug#/Bug #/gi;
  $message =~s/\Ww\.d\.o/ www.d.o/gi;
  $message =~s/\Wp\.d\.o/ people.d.o/gi;
  $message =~s/\Ws\.d\.o/ satie.d.o/gi;
  $message =~s/\Wppl\.d\.o/ people.d.o/gi;
  $message =~s/\.d\.o/.debian.org/gi;
  $message =~s/\@d\.o/\@debian.org/gi;
  $message =~s/(^|http:\/\/| |\W)(\w+\.debian\.org)/ http:\/\/$2/g;
  $message =~s/#(\d+)/http:\/\/bugs.debian.org\/cgi-bin\/mime\/bugreport.cgi?archive=yes\&bug=$1/g;

	if($msg_prev ne $message) {
   eval "\$print_text = \"$formats{$msg_type}\"";
   IRC::print("\cC9\cB *** URL expansion ***\cO: $print_text\n");
	}
	return 0;
}

